  // FL  
  // Testare con : http://192.168.1.107/?PULSE=1000&DLY=1000&PULSE=5000          
  
  // Testare con : http://192.168.1.107/?RLY=ON
  // Testare con : http://192.168.1.107/?RLY=OFF
  
  // FL 

#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include <ESP8266mDNS.h>

const char* ssid = "Inserire la propria rete";
const char* password = "Inserire la propria password";

ESP8266WebServer server(80);

const int led = 13;
const int relay = 12;

void setup(void){
  pinMode(led, OUTPUT);
  pinMode(relay, OUTPUT);
  digitalWrite(led, 0);
  Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  Serial.println("");

//FL     Imposta l'indirizzo statico dell'interfaccia Wifi del sonoff
    IPAddress ip(192,168,1,107);
    IPAddress gateway(192,168,1,1);
    IPAddress subnet(255,255,255,0);
    WiFi.config(ip,gateway,subnet);
//FL

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());

  if (MDNS.begin("esp8266")) {
    Serial.println("MDNS responder started");
  }

  server.on("/", handleRoot);

  server.on("/inline", [](){
    server.send(200, "text/plain", "this works as well");
  });

  server.onNotFound(handleNotFound);

  server.begin();
  Serial.println("HTTP server started");
}

void loop(void){
  server.handleClient();
}



void handleRoot() {
  int k;
  String str="2500";
  
  digitalWrite(led, 1);

  String message = "hello from esp8266!\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message += (server.method() == HTTP_GET)?"GET":"POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";
  for (uint8_t i=0; i<server.args(); i++){
    message += " " + server.argName(i) + ": " + server.arg(i) + "\n";

    if (server.argName(i) == "RLY") 
    {
      if (server.arg(i) == "ON") 
      {
        digitalWrite(relay, HIGH);
      }
      
      if (server.arg(i) == "OFF") 
      {
        digitalWrite(relay, LOW);
      }
    }

    if (server.argName(i) == "PULSE")
    {
        str = server.arg(i);
        k = atoi(str.c_str());
        digitalWrite(relay, HIGH);        
        delay(k);                         
        digitalWrite(relay, LOW);         
    }

    if (server.argName(i) == "DLY")
    {
        // k = atoi(server.arg(i));
        str = server.arg(i);
        k = atoi(str.c_str());
        delay(k);                 
    }

  }
  server.send(200, "text/plain", message);
  
  digitalWrite(led, 0);
}

void handleNotFound(){
  digitalWrite(led, 1);
  String message = "File Not Found\n\n";
  message += "URI: ";
  message += server.uri();
  message += "\nMethod: ";
  message += (server.method() == HTTP_GET)?"GET":"POST";
  message += "\nArguments: ";
  message += server.args();
  message += "\n";
  for (uint8_t i=0; i<server.args(); i++){
    message += " " + server.argName(i) + ": " + server.arg(i) + "\n";
  }
  server.send(404, "text/plain", message);
  digitalWrite(led, 0);
}

